# @(#)89  1.5 src/cmdline/staging/scripts/modify_federation.py, amws.cmdline, fim611, 060921a 9/18/06 16:18:33
# (C) Copyright International Business Machines Corporation 2005. All rights
# reserved.  U.S. Government Users Restricted Rights -- Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 
from fim_base import read_properties_file, commit_session
from fed_utils import get_federation, show_federation, set_federation_properties
from domain_utils import is_domain_present
from com.tivoli.am.fim.logging import FIMLoggerFactory
from com.tivoli.am.fim.logging import FIMLogger
from com.tivoli.am.fim.logging import FIMLevel
from com.tivoli.am.fim.i18n.msgs import CmdLineMessages
from jarray import array
from java.lang import Object
from com.tivoli.am.fim.logging import FIMLoggerConstants

# Set up FIMLogger
component_name = "StagingTools"
script_name = "modify_federation.py"
method_name = script_name
class_name = "com.tivoli.am.fim.cmdline." + script_name[0:-3]
FIMLoggerFactory.enableStdout(FIMLevel.ALL)
FIMLoggerFactory.setPreferredFIMLoggerImpl(FIMLoggerConstants.FIMLOGGER_BASE_IMPL)
log = FIMLoggerFactory.getFIMLogger(component_name, class_name, CmdLineMessages.CLASS_NAME)

def usage():
    inserts = array([script_name],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.usage_modify_federation, \
        inserts)
    raise SystemExit

if __name__ == 'main':
    
    if len(sys.argv) < 3:
        usage()

    props_file = sys.argv[0]
    user_props_file = sys.argv[1]
    fed_name = sys.argv[2]
    
    props = read_properties_file(props_file)
    if not is_domain_present(props):
        raise SystemExit

    # Get the federation object and federation manager
    (fed, fed_mgr) = get_federation(fed_name, props_file)    
    
    # Get the user-defined properties for the federation from the props file
    user_props = read_properties_file(user_props_file)

    if fed:
        # Update the federation with the user-specified properties
        set_federation_properties(fed, user_props)
        inserts = array([fed_name], Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.modified_federation_successfully, inserts) 
        commit_session(fed_mgr)
    else:
        inserts = array([fed_name], Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.federation_does_not_exist, inserts)
        raise SystemExit

    raise SystemExit

